# 2013.03.25 16:03:32 CET
#Embedded file name: /home/morser/Azbox/OpenSPA2/build-vuultimo/tmp/work/mips32el-oe-linux/enigma2-plugin-extensions-spzweather-1.0-r3/plugin/setup.py
from enigma import eListboxPythonMultiContent, eListbox, gFont, RT_HALIGN_LEFT, RT_VALIGN_CENTER
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.MenuList import MenuList
from Components.Button import Button
from Components.config import config
from Components.ActionMap import ActionMap, NumberActionMap
from Components.ConfigList import ConfigList, ConfigListScreen
from Components.config import ConfigSubsection, ConfigSubList, ConfigIP, ConfigInteger, ConfigSelection, ConfigText, ConfigYesNo, getConfigListEntry, configfile
from os import environ
import gettext
from Components.Language import language
from Tools.Directories import resolveFilename, SCOPE_PLUGINS, SCOPE_LANGUAGE
lang = language.getLanguage()
environ['LANGUAGE'] = lang[:2]
lenguaje = str(lang[:2])
gettext.bindtextdomain('enigma2', resolveFilename(SCOPE_LANGUAGE))
gettext.textdomain('enigma2')
gettext.bindtextdomain('spzWeather', '%s%s' % (resolveFilename(SCOPE_PLUGINS), 'Extensions/spzWeather/locale/'))

def _(txt):
    t = gettext.dgettext('spzWeather', txt)
    if t == txt:
        t = gettext.gettext(txt)
    return t


def initWeatherPluginEntryConfig():
    config.plugins.spzWeatherPlugin.Entries.append(ConfigSubsection())
    i = len(config.plugins.spzWeatherPlugin.Entries) - 1
    config.plugins.spzWeatherPlugin.Entries[i].city = ConfigText(default='Krasnodar', visible_width=50, fixed_size=False)
    config.plugins.spzWeatherPlugin.Entries[i].language = ConfigText(default='ru', visible_width=50, fixed_size=False)
    return config.plugins.spzWeatherPlugin.Entries[i]


def initWeatherPluginEntryConfigacu():
    config.plugins.spzWeatherPlugin.acuEntries.append(ConfigSubsection())
    i = len(config.plugins.spzWeatherPlugin.acuEntries) - 1
    config.plugins.spzWeatherPlugin.acuEntries[i].city = ConfigText(default='Pontevedra', visible_width=50, fixed_size=False)
    config.plugins.spzWeatherPlugin.acuEntries[i].comunity = ConfigText(default='Galicia', visible_width=50, fixed_size=False)
    config.plugins.spzWeatherPlugin.acuEntries[i].pais = ConfigText(default='es', visible_width=50, fixed_size=False)
    config.plugins.spzWeatherPlugin.acuEntries[i].language = ConfigText(default='es', visible_width=50, fixed_size=False)
    return config.plugins.spzWeatherPlugin.acuEntries[i]


def initWeatherPluginEntryConfigfore():
    config.plugins.spzWeatherPlugin.foreEntries.append(ConfigSubsection())
    i = len(config.plugins.spzWeatherPlugin.foreEntries) - 1
    config.plugins.spzWeatherPlugin.foreEntries[i].city = ConfigText(default='Krasnodar', visible_width=50, fixed_size=False)
    config.plugins.spzWeatherPlugin.foreEntries[i].pais = ConfigText(default='Russia', visible_width=50, fixed_size=False)
    config.plugins.spzWeatherPlugin.foreEntries[i].dominio = ConfigText(default='ru', visible_width=50, fixed_size=False)
    return config.plugins.spzWeatherPlugin.foreEntries[i]


def initConfig():
    count = config.plugins.spzWeatherPlugin.entriescount.value
    if count != 0:
        i = 0
        while i < count:
            initWeatherPluginEntryConfig()
            i += 1


def initConfigacu():
    count = config.plugins.spzWeatherPlugin.acuentriescount.value
    if count != 0:
        i = 0
        while i < count:
            initWeatherPluginEntryConfigacu()
            i += 1


def initConfigfore():
    count = config.plugins.spzWeatherPlugin.foreentriescount.value
    if count != 0:
        i = 0
        while i < count:
            initWeatherPluginEntryConfigfore()
            i += 1


class WeatherPluginEntriesListConfigScreenfore(Screen):
    skin = '\n\t\t<screen position="center,center" size="750,400" title="%s %s" >\n\t\t\t<widget name="city" position="5,0" size="150,50" font="Regular;20" halign="left"/>\n\t\t\t<widget name="language" position="155,0" size="150,50" font="Regular;20" halign="left"/>\n\t\t\t<widget name="entrylist" position="0,50" size="750,300" scrollbarMode="showOnDemand"/>\n\t\t\t<widget name="key_red" position="0,350" size="140,40" zPosition="5" valign="center" halign="center" backgroundColor="red" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\t<widget name="key_green" position="140,350" size="140,40" zPosition="5" valign="center" halign="center" backgroundColor="red" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\t\t\t\n\t\t\t<widget name="key_yellow" position="280,350" size="140,40" zPosition="5" valign="center" halign="center" backgroundColor="yellow" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\t<widget name="key_blue" position="420,350" zPosition="5" size="140,40" valign="center" halign="center" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\t<ePixmap name="red" position="0,350" zPosition="4" size="140,40" pixmap="skin_default/buttons/red.png" transparent="1" alphatest="on" />\n\t\t\t<ePixmap name="green" position="140,350" zPosition="4" size="140,40" pixmap="skin_default/buttons/green.png" transparent="1" alphatest="on" />\n\t\t\t<ePixmap name="yellow" position="280,350" zPosition="4" size="140,40" pixmap="skin_default/buttons/yellow.png" transparent="1" alphatest="on" />\n\t\t\t<ePixmap name="blue" position="420,350" zPosition="4" size="140,40" pixmap="skin_default/buttons/blue.png" transparent="1" alphatest="on" />\n\t\t</screen>' % (_('spazeTeam WeatherPlugin: List of Entries'), '(foreca.com)')

    def __init__(self, session):
        Screen.__init__(self, session)
        self.session = session
        self['city'] = Button(_('City'))
        self['language'] = Button(_('Country'))
        self['key_red'] = Button(_('Add'))
        self['key_green'] = Button(_('Default'))
        self['key_yellow'] = Button(_('Edit'))
        self['key_blue'] = Button(_('Delete'))
        self['entrylist'] = WeatherPluginEntryListfore([])
        self['actions'] = ActionMap(['WizardActions', 'MenuActions', 'ShortcutActions'], {'ok': self.keyOK,
         'back': self.keyClose,
         'green': self.keyGreen,
         'red': self.keyRed,
         'yellow': self.keyYellow,
         'blue': self.keyDelete}, -1)
        self.updateList()

    def updateList(self):
        self['entrylist'].buildList()

    def keyClose(self):
        self.close(-1, None)

    def keyRed(self):
        self.session.openWithCallback(self.updateList, WeatherPluginEntryConfigScreenfore, None)

    def keyGreen(self):
        if len(self['entrylist'].list) <= 0:
            return
        sel = self['entrylist'].getCurrentIndex()
        defacity = config.plugins.spzWeatherPlugin.foreEntries[sel].city.value
        defapais = config.plugins.spzWeatherPlugin.foreEntries[sel].pais.value
        defacom = config.plugins.spzWeatherPlugin.foreEntries[sel].dominio.value
        config.plugins.spzWeatherPlugin.foreEntries[sel].city.value = config.plugins.spzWeatherPlugin.foreEntries[0].city.value
        config.plugins.spzWeatherPlugin.foreEntries[sel].pais.value = config.plugins.spzWeatherPlugin.foreEntries[0].pais.value
        config.plugins.spzWeatherPlugin.foreEntries[sel].dominio.value = config.plugins.spzWeatherPlugin.foreEntries[0].dominio.value
        config.plugins.spzWeatherPlugin.foreEntries[0].city.value = defacity
        config.plugins.spzWeatherPlugin.foreEntries[0].pais.value = defapais
        config.plugins.spzWeatherPlugin.foreEntries[0].dominio.value = defacom
        config.plugins.spzWeatherPlugin.foreentriescount.save()
        config.plugins.spzWeatherPlugin.foreEntries.save()
        config.plugins.spzWeatherPlugin.save()
        configfile.save()
        self.updateList()

    def keyOK(self):
        try:
            sel = self['entrylist'].l.getCurrentSelection()[0]
        except:
            sel = None

        self.close(self['entrylist'].getCurrentIndex(), sel)

    def keyYellow(self):
        try:
            sel = self['entrylist'].l.getCurrentSelection()[0]
        except:
            sel = None

        if sel is None:
            return
        self.session.openWithCallback(self.updateList, WeatherPluginEntryConfigScreenfore, sel)

    def keyDelete(self):
        try:
            sel = self['entrylist'].l.getCurrentSelection()[0]
        except:
            sel = None

        if sel is None:
            return
        self.session.openWithCallback(self.deleteConfirm, MessageBox, _('Really delete this WeatherPlugin Entry?'))

    def deleteConfirm(self, result):
        if not result:
            return
        sel = self['entrylist'].l.getCurrentSelection()[0]
        config.plugins.spzWeatherPlugin.foreentriescount.value = config.plugins.spzWeatherPlugin.foreentriescount.value - 1
        config.plugins.spzWeatherPlugin.foreentriescount.save()
        config.plugins.spzWeatherPlugin.foreEntries.remove(sel)
        config.plugins.spzWeatherPlugin.foreEntries.save()
        config.plugins.spzWeatherPlugin.save()
        configfile.save()
        self.updateList()


class WeatherPluginEntryListfore(MenuList):

    def __init__(self, list, enableWrapAround = True):
        MenuList.__init__(self, list, enableWrapAround, eListboxPythonMultiContent)
        self.l.setFont(0, gFont('Regular', 20))
        self.l.setFont(1, gFont('Regular', 18))

    def postWidgetCreate(self, instance):
        MenuList.postWidgetCreate(self, instance)
        instance.setItemHeight(20)

    def getCurrentIndex(self):
        return self.instance.getCurrentIndex()

    def buildList(self):
        self.list = []
        for c in config.plugins.spzWeatherPlugin.foreEntries:
            res = [c]
            res.append((eListboxPythonMultiContent.TYPE_TEXT,
             5,
             0,
             150,
             20,
             1,
             RT_HALIGN_LEFT | RT_VALIGN_CENTER,
             str(c.city.value)))
            tvalor = str(c.pais.value) + ' (.' + str(c.dominio.value) + ')'
            res.append((eListboxPythonMultiContent.TYPE_TEXT,
             155,
             0,
             150,
             20,
             1,
             RT_HALIGN_LEFT | RT_VALIGN_CENTER,
             tvalor))
            self.list.append(res)

        self.l.setList(self.list)
        self.moveToIndex(0)


class WeatherPluginEntryConfigScreenfore(ConfigListScreen, Screen):
    skin = '\n\t\t<screen name="WeatherPluginEntryConfigScreen" position="center,center" size="750,276" title="%s%s">\n\t\t\t<widget name="config" position="20,10" size="720,200" scrollbarMode="showOnDemand" />\n\t\t\t<ePixmap name="red" position="10,225" zPosition="4" size="140,40" pixmap="skin_default/buttons/red.png" transparent="1" alphatest="on" />\n\t\t\t<ePixmap name="green" position="167,225" zPosition="4" size="140,40" pixmap="skin_default/buttons/green.png" transparent="1" alphatest="on" />\n\n\t\t\t<ePixmap name="blue" position="319,225" zPosition="4" size="140,40" pixmap="skin_default/buttons/blue.png" transparent="1" alphatest="on" />\n\n\t\t\t<widget name="key_red" position="10,225" zPosition="5" size="140,40" valign="center" halign="center" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\t<widget name="key_green" position="166,225" zPosition="5" size="140,40" valign="center" halign="center" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\n\t\t\t<widget name="key_blue" position="319,225" zPosition="5" size="140,40" valign="center" halign="center" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t</screen>' % (_('spazeTeam WeatherPlugin: Edit Entry'), '(foreca.com)')

    def __init__(self, session, entry):
        self.session = session
        Screen.__init__(self, session)
        self['actions'] = ActionMap(['SetupActions', 'ColorActions'], {'green': self.keySave,
         'red': self.keyCancel,
         'blue': self.keyDelete,
         'cancel': self.keyCancel}, -2)
        self['key_red'] = Button(_('Cancel'))
        self['key_green'] = Button(_('Save'))
        self['key_blue'] = Button(_('Delete'))
        if entry is None:
            self.newmode = 1
            self.current = initWeatherPluginEntryConfigfore()
        else:
            self.newmode = 0
            self.current = entry
        cfglist = [getConfigListEntry(_('City'), self.current.city), getConfigListEntry(_('Country'), self.current.pais), getConfigListEntry(_('Domain') + ' (' + _('Language') + ')', self.current.dominio)]
        ConfigListScreen.__init__(self, cfglist, session)

    def keySave(self):
        if self.newmode == 1:
            config.plugins.spzWeatherPlugin.foreentriescount.value = config.plugins.spzWeatherPlugin.foreentriescount.value + 1
            config.plugins.spzWeatherPlugin.foreentriescount.save()
        ConfigListScreen.keySave(self)
        config.plugins.spzWeatherPlugin.save()
        configfile.save()
        self.close()

    def keyCancel(self):
        if self.newmode == 1:
            config.plugins.spzWeatherPlugin.foreEntries.remove(self.current)
        ConfigListScreen.cancelConfirm(self, True)

    def keyDelete(self):
        if self.newmode == 1:
            self.keyCancel()
        else:
            self.session.openWithCallback(self.deleteConfirm, MessageBox, _('Really delete this WeatherPlugin Entry?'))

    def deleteConfirm(self, result):
        if not result:
            return
        config.plugins.spzWeatherPlugin.foreentriescount.value = config.plugins.spzWeatherPlugin.foreentriescount.value - 1
        config.plugins.spzWeatherPlugin.foreentriescount.save()
        config.plugins.spzWeatherPlugin.foreEntries.remove(self.current)
        config.plugins.spzWeatherPlugin.foreEntries.save()
        config.plugins.spzWeatherPlugin.foresave()
        configfile.save()
        self.close()


class WeatherPluginEntriesListConfigScreenacu(Screen):
    skin = '\n\t\t<screen position="center,center" size="750,400" title="%s %s" >\n\t\t\t<widget name="city" position="5,0" size="150,50" font="Regular;20" halign="left"/>\n\t\t\t<widget name="language" position="155,0" size="150,50" font="Regular;20" halign="left"/>\n\t\t\t<widget name="entrylist" position="0,50" size="750,300" scrollbarMode="showOnDemand"/>\n\t\t\t<widget name="key_red" position="0,350" size="140,40" zPosition="5" valign="center" halign="center" backgroundColor="red" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\t<widget name="key_green" position="140,350" size="140,40" zPosition="5" valign="center" halign="center" backgroundColor="red" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\t\t\t\n\t\t\t<widget name="key_yellow" position="280,350" size="140,40" zPosition="5" valign="center" halign="center" backgroundColor="yellow" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\t<widget name="key_blue" position="420,350" zPosition="5" size="140,40" valign="center" halign="center" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\t<ePixmap name="red" position="0,350" zPosition="4" size="140,40" pixmap="skin_default/buttons/red.png" transparent="1" alphatest="on" />\n\t\t\t<ePixmap name="green" position="140,350" zPosition="4" size="140,40" pixmap="skin_default/buttons/green.png" transparent="1" alphatest="on" />\n\t\t\t<ePixmap name="yellow" position="280,350" zPosition="4" size="140,40" pixmap="skin_default/buttons/yellow.png" transparent="1" alphatest="on" />\n\t\t\t<ePixmap name="blue" position="420,350" zPosition="4" size="140,40" pixmap="skin_default/buttons/blue.png" transparent="1" alphatest="on" />\n\t\t</screen>' % (_('spazeTeam WeatherPlugin: List of Entries'), '(accuwheater.com)')

    def __init__(self, session):
        Screen.__init__(self, session)
        self.session = session
        self['city'] = Button(_('City'))
        self['language'] = Button(_('Language'))
        self['key_red'] = Button(_('Add'))
        self['key_green'] = Button(_('Default'))
        self['key_yellow'] = Button(_('Edit'))
        self['key_blue'] = Button(_('Delete'))
        self['entrylist'] = WeatherPluginEntryListacu([])
        self['actions'] = ActionMap(['WizardActions', 'MenuActions', 'ShortcutActions'], {'ok': self.keyOK,
         'back': self.keyClose,
         'green': self.keyGreen,
         'red': self.keyRed,
         'yellow': self.keyYellow,
         'blue': self.keyDelete}, -1)
        self.updateList()

    def updateList(self):
        self['entrylist'].buildList()

    def keyClose(self):
        self.close(-1, None)

    def keyRed(self):
        self.session.openWithCallback(self.updateList, WeatherPluginEntryConfigScreenacu, None)

    def keyGreen(self):
        if len(self['entrylist'].list) <= 0:
            return
        sel = self['entrylist'].getCurrentIndex()
        defacity = config.plugins.spzWeatherPlugin.acuEntries[sel].city.value
        defacomu = config.plugins.spzWeatherPlugin.acuEntries[sel].comunity.value
        defapais = config.plugins.spzWeatherPlugin.acuEntries[sel].pais.value
        defalan = config.plugins.spzWeatherPlugin.acuEntries[sel].language.value
        config.plugins.spzWeatherPlugin.acuEntries[sel].city.value = config.plugins.spzWeatherPlugin.acuEntries[0].city.value
        config.plugins.spzWeatherPlugin.acuEntries[sel].pais.value = config.plugins.spzWeatherPlugin.acuEntries[0].pais.value
        config.plugins.spzWeatherPlugin.acuEntries[sel].comunity.value = config.plugins.spzWeatherPlugin.acuEntries[0].comunity.value
        config.plugins.spzWeatherPlugin.acuEntries[sel].language.value = config.plugins.spzWeatherPlugin.acuEntries[0].language.value
        config.plugins.spzWeatherPlugin.acuEntries[0].city.value = defacity
        config.plugins.spzWeatherPlugin.acuEntries[0].pais.value = defapais
        config.plugins.spzWeatherPlugin.acuEntries[0].comunity.value = defacomu
        config.plugins.spzWeatherPlugin.acuEntries[0].language.value = defalan
        config.plugins.spzWeatherPlugin.acuentriescount.save()
        config.plugins.spzWeatherPlugin.acuEntries.save()
        config.plugins.spzWeatherPlugin.save()
        configfile.save()
        self.updateList()

    def keyOK(self):
        try:
            sel = self['entrylist'].l.getCurrentSelection()[0]
        except:
            sel = None

        self.close(self['entrylist'].getCurrentIndex(), sel)

    def keyYellow(self):
        try:
            sel = self['entrylist'].l.getCurrentSelection()[0]
        except:
            sel = None

        if sel is None:
            return
        self.session.openWithCallback(self.updateList, WeatherPluginEntryConfigScreenacu, sel)

    def keyDelete(self):
        try:
            sel = self['entrylist'].l.getCurrentSelection()[0]
        except:
            sel = None

        if sel is None:
            return
        self.session.openWithCallback(self.deleteConfirm, MessageBox, _('Really delete this WeatherPlugin Entry?'))

    def deleteConfirm(self, result):
        if not result:
            return
        sel = self['entrylist'].l.getCurrentSelection()[0]
        config.plugins.spzWeatherPlugin.acuentriescount.value = config.plugins.spzWeatherPlugin.acuentriescount.value - 1
        config.plugins.spzWeatherPlugin.acuentriescount.save()
        config.plugins.spzWeatherPlugin.acuEntries.remove(sel)
        config.plugins.spzWeatherPlugin.acuEntries.save()
        config.plugins.spzWeatherPlugin.save()
        configfile.save()
        self.updateList()


class WeatherPluginEntriesListConfigScreen(Screen):
    skin = '\n\t\t<screen position="center,center" size="750,400" title="%s %s" >\n\t\t\t<widget name="city" position="5,0" size="150,50" font="Regular;20" halign="left"/>\n\t\t\t<widget name="language" position="155,0" size="150,50" font="Regular;20" halign="left"/>\n\t\t\t<widget name="entrylist" position="0,50" size="750,300" scrollbarMode="showOnDemand"/>\n\t\t\t<widget name="key_red" position="0,350" size="140,40" zPosition="5" valign="center" halign="center" backgroundColor="red" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\t<widget name="key_green" position="140,350" size="140,40" zPosition="5" valign="center" halign="center" backgroundColor="red" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\t\t\t\n\t\t\t<widget name="key_yellow" position="280,350" size="140,40" zPosition="5" valign="center" halign="center" backgroundColor="yellow" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\t<widget name="key_blue" position="420,350" zPosition="5" size="140,40" valign="center" halign="center" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\t<ePixmap name="red" position="0,350" zPosition="4" size="140,40" pixmap="skin_default/buttons/red.png" transparent="1" alphatest="on" />\n\t\t\t<ePixmap name="green" position="140,350" zPosition="4" size="140,40" pixmap="skin_default/buttons/green.png" transparent="1" alphatest="on" />\n\t\t\t<ePixmap name="yellow" position="280,350" zPosition="4" size="140,40" pixmap="skin_default/buttons/yellow.png" transparent="1" alphatest="on" />\n\t\t\t<ePixmap name="blue" position="420,350" zPosition="4" size="140,40" pixmap="skin_default/buttons/blue.png" transparent="1" alphatest="on" />\n\t\t</screen>' % (_('spazeTeam WeatherPlugin: List of Entries'), '(google.com)')

    def __init__(self, session):
        Screen.__init__(self, session)
        self.session = session
        self['city'] = Button(_('City'))
        self['language'] = Button(_('Language'))
        self['key_red'] = Button(_('Add'))
        self['key_green'] = Button(_('Default'))
        self['key_yellow'] = Button(_('Edit'))
        self['key_blue'] = Button(_('Delete'))
        self['entrylist'] = WeatherPluginEntryList([])
        self['actions'] = ActionMap(['WizardActions', 'MenuActions', 'ShortcutActions'], {'ok': self.keyOK,
         'back': self.keyClose,
         'green': self.keyGreen,
         'red': self.keyRed,
         'yellow': self.keyYellow,
         'blue': self.keyDelete}, -1)
        self.updateList()

    def updateList(self):
        self['entrylist'].buildList()

    def keyClose(self):
        self.close(-1, None)

    def keyRed(self):
        self.session.openWithCallback(self.updateList, WeatherPluginEntryConfigScreen, None)

    def keyGreen(self):
        if len(self['entrylist'].list) <= 0:
            return
        sel = self['entrylist'].getCurrentIndex()
        defacity = config.plugins.spzWeatherPlugin.Entries[sel].city.value
        defalan = config.plugins.spzWeatherPlugin.Entries[sel].language.value
        config.plugins.spzWeatherPlugin.Entries[sel].city.value = config.plugins.spzWeatherPlugin.Entries[0].city.value
        config.plugins.spzWeatherPlugin.Entries[sel].language.value = config.plugins.spzWeatherPlugin.Entries[0].language.value
        config.plugins.spzWeatherPlugin.Entries[0].city.value = defacity
        config.plugins.spzWeatherPlugin.Entries[0].language.value = defalan
        config.plugins.spzWeatherPlugin.entriescount.save()
        config.plugins.spzWeatherPlugin.Entries.save()
        config.plugins.spzWeatherPlugin.save()
        configfile.save()
        self.updateList()

    def keyOK(self):
        try:
            sel = self['entrylist'].l.getCurrentSelection()[0]
        except:
            sel = None

        self.close(self['entrylist'].getCurrentIndex(), sel)

    def keyYellow(self):
        try:
            sel = self['entrylist'].l.getCurrentSelection()[0]
        except:
            sel = None

        if sel is None:
            return
        self.session.openWithCallback(self.updateList, WeatherPluginEntryConfigScreen, sel)

    def keyDelete(self):
        try:
            sel = self['entrylist'].l.getCurrentSelection()[0]
        except:
            sel = None

        if sel is None:
            return
        self.session.openWithCallback(self.deleteConfirm, MessageBox, _('Really delete this WeatherPlugin Entry?'))

    def deleteConfirm(self, result):
        if not result:
            return
        sel = self['entrylist'].l.getCurrentSelection()[0]
        config.plugins.spzWeatherPlugin.entriescount.value = config.plugins.spzWeatherPlugin.entriescount.value - 1
        config.plugins.spzWeatherPlugin.entriescount.save()
        config.plugins.spzWeatherPlugin.Entries.remove(sel)
        config.plugins.spzWeatherPlugin.Entries.save()
        config.plugins.spzWeatherPlugin.save()
        configfile.save()
        self.updateList()


class WeatherPluginEntryList(MenuList):

    def __init__(self, list, enableWrapAround = True):
        MenuList.__init__(self, list, enableWrapAround, eListboxPythonMultiContent)
        self.l.setFont(0, gFont('Regular', 20))
        self.l.setFont(1, gFont('Regular', 18))

    def postWidgetCreate(self, instance):
        MenuList.postWidgetCreate(self, instance)
        instance.setItemHeight(20)

    def getCurrentIndex(self):
        return self.instance.getCurrentIndex()

    def buildList(self):
        self.list = []
        for c in config.plugins.spzWeatherPlugin.Entries:
            res = [c]
            res.append((eListboxPythonMultiContent.TYPE_TEXT,
             5,
             0,
             150,
             20,
             1,
             RT_HALIGN_LEFT | RT_VALIGN_CENTER,
             str(c.city.value)))
            res.append((eListboxPythonMultiContent.TYPE_TEXT,
             155,
             0,
             150,
             20,
             1,
             RT_HALIGN_LEFT | RT_VALIGN_CENTER,
             str(c.language.value)))
            self.list.append(res)

        self.l.setList(self.list)
        self.moveToIndex(0)


class WeatherPluginEntryListacu(MenuList):

    def __init__(self, list, enableWrapAround = True):
        MenuList.__init__(self, list, enableWrapAround, eListboxPythonMultiContent)
        self.l.setFont(0, gFont('Regular', 20))
        self.l.setFont(1, gFont('Regular', 18))

    def postWidgetCreate(self, instance):
        MenuList.postWidgetCreate(self, instance)
        instance.setItemHeight(20)

    def getCurrentIndex(self):
        return self.instance.getCurrentIndex()

    def buildList(self):
        self.list = []
        for c in config.plugins.spzWeatherPlugin.acuEntries:
            res = [c]
            res.append((eListboxPythonMultiContent.TYPE_TEXT,
             5,
             0,
             150,
             20,
             1,
             RT_HALIGN_LEFT | RT_VALIGN_CENTER,
             str(c.city.value)))
            res.append((eListboxPythonMultiContent.TYPE_TEXT,
             155,
             0,
             150,
             20,
             1,
             RT_HALIGN_LEFT | RT_VALIGN_CENTER,
             str(c.language.value)))
            self.list.append(res)

        self.l.setList(self.list)
        self.moveToIndex(0)


class WeatherPluginEntryConfigScreenacu(ConfigListScreen, Screen):
    skin = '\n\t\t<screen name="WeatherPluginEntryConfigScreenacu" position="center,center" size="750,276" title="%s %s">\n\t\t\t<widget name="config" position="20,10" size="720,200" scrollbarMode="showOnDemand" />\n\t\t\t<ePixmap name="red" position="10,225" zPosition="4" size="140,40" pixmap="skin_default/buttons/red.png" transparent="1" alphatest="on" />\n\t\t\t<ePixmap name="green" position="167,225" zPosition="4" size="140,40" pixmap="skin_default/buttons/green.png" transparent="1" alphatest="on" />\n\n\t\t\t<ePixmap name="blue" position="319,225" zPosition="4" size="140,40" pixmap="skin_default/buttons/blue.png" transparent="1" alphatest="on" />\n\n\t\t\t<widget name="key_red" position="10,225" zPosition="5" size="140,40" valign="center" halign="center" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\t<widget name="key_green" position="166,225" zPosition="5" size="140,40" valign="center" halign="center" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\n\t\t\t<widget name="key_blue" position="319,225" zPosition="5" size="140,40" valign="center" halign="center" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t</screen>' % (_('spazeTeam WeatherPlugin: Edit Entry'), '(accuwheater.com)')

    def __init__(self, session, entry):
        self.session = session
        Screen.__init__(self, session)
        self['actions'] = ActionMap(['SetupActions', 'ColorActions'], {'green': self.keySave,
         'red': self.keyCancel,
         'blue': self.keyDelete,
         'cancel': self.keyCancel}, -2)
        self['key_red'] = Button(_('Cancel'))
        self['key_green'] = Button(_('Save'))
        self['key_blue'] = Button(_('Delete'))
        if entry is None:
            self.newmode = 1
            self.current = initWeatherPluginEntryConfigacu()
        else:
            self.newmode = 0
            self.current = entry
        cfglist = [getConfigListEntry(_('City'), self.current.city),
         getConfigListEntry(_('Comunity'), self.current.comunity),
         getConfigListEntry(_('Country'), self.current.pais),
         getConfigListEntry(_('Language'), self.current.language)]
        ConfigListScreen.__init__(self, cfglist, session)

    def keySave(self):
        if self.newmode == 1:
            config.plugins.spzWeatherPlugin.acuentriescount.value = config.plugins.spzWeatherPlugin.acuentriescount.value + 1
            config.plugins.spzWeatherPlugin.acuentriescount.save()
        ConfigListScreen.keySave(self)
        config.plugins.spzWeatherPlugin.save()
        configfile.save()
        self.close()

    def keyCancel(self):
        if self.newmode == 1:
            config.plugins.spzWeatherPlugin.acuEntries.remove(self.current)
        ConfigListScreen.cancelConfirm(self, True)

    def keyDelete(self):
        if self.newmode == 1:
            self.keyCancel()
        else:
            self.session.openWithCallback(self.deleteConfirm, MessageBox, _('Really delete this WeatherPlugin Entry?'))

    def deleteConfirm(self, result):
        if not result:
            return
        config.plugins.spzWeatherPlugin.acuentriescount.value = config.plugins.spzWeatherPlugin.acuentriescount.value - 1
        config.plugins.spzWeatherPlugin.acuentriescount.save()
        config.plugins.spzWeatherPlugin.acuEntries.remove(self.current)
        config.plugins.spzWeatherPlugin.acuEntries.save()
        config.plugins.spzWeatherPlugin.save()
        configfile.save()
        self.close()


class WeatherPluginEntryConfigScreen(ConfigListScreen, Screen):
    skin = '\n\t\t<screen name="WeatherPluginEntryConfigScreen" position="center,center" size="750,276" title="%s%s">\n\t\t\t<widget name="config" position="20,10" size="720,200" scrollbarMode="showOnDemand" />\n\t\t\t<ePixmap name="red" position="10,225" zPosition="4" size="140,40" pixmap="skin_default/buttons/red.png" transparent="1" alphatest="on" />\n\t\t\t<ePixmap name="green" position="167,225" zPosition="4" size="140,40" pixmap="skin_default/buttons/green.png" transparent="1" alphatest="on" />\n\n\t\t\t<ePixmap name="blue" position="319,225" zPosition="4" size="140,40" pixmap="skin_default/buttons/blue.png" transparent="1" alphatest="on" />\n\n\t\t\t<widget name="key_red" position="10,225" zPosition="5" size="140,40" valign="center" halign="center" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\t<widget name="key_green" position="166,225" zPosition="5" size="140,40" valign="center" halign="center" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t\n\t\t\t<widget name="key_blue" position="319,225" zPosition="5" size="140,40" valign="center" halign="center" font="Regular;21" transparent="1" foregroundColor="white" shadowColor="black" shadowOffset="-1,-1" />\n\t\t</screen>' % (_('spazeTeam WeatherPlugin: Edit Entry'), '(google.com)')

    def __init__(self, session, entry):
        self.session = session
        Screen.__init__(self, session)
        self['actions'] = ActionMap(['SetupActions', 'ColorActions'], {'green': self.keySave,
         'red': self.keyCancel,
         'blue': self.keyDelete,
         'cancel': self.keyCancel}, -2)
        self['key_red'] = Button(_('Cancel'))
        self['key_green'] = Button(_('Save'))
        self['key_blue'] = Button(_('Delete'))
        if entry is None:
            self.newmode = 1
            self.current = initWeatherPluginEntryConfig()
        else:
            self.newmode = 0
            self.current = entry
        cfglist = [getConfigListEntry(_('City or Postal Code'), self.current.city), getConfigListEntry(_('Language'), self.current.language)]
        ConfigListScreen.__init__(self, cfglist, session)

    def keySave(self):
        if self.newmode == 1:
            config.plugins.spzWeatherPlugin.entriescount.value = config.plugins.spzWeatherPlugin.entriescount.value + 1
            config.plugins.spzWeatherPlugin.entriescount.save()
        ConfigListScreen.keySave(self)
        config.plugins.spzWeatherPlugin.save()
        configfile.save()
        self.close()

    def keyCancel(self):
        if self.newmode == 1:
            config.plugins.spzWeatherPlugin.Entries.remove(self.current)
        ConfigListScreen.cancelConfirm(self, True)

    def keyDelete(self):
        if self.newmode == 1:
            self.keyCancel()
        else:
            self.session.openWithCallback(self.deleteConfirm, MessageBox, _('Really delete this WeatherPlugin Entry?'))

    def deleteConfirm(self, result):
        if not result:
            return
        config.plugins.spzWeatherPlugin.entriescount.value = config.plugins.spzWeatherPlugin.entriescount.value - 1
        config.plugins.spzWeatherPlugin.entriescount.save()
        config.plugins.spzWeatherPlugin.Entries.remove(self.current)
        config.plugins.spzWeatherPlugin.Entries.save()
        config.plugins.spzWeatherPlugin.save()
        configfile.save()
        self.close()
